#include "Mouse.h"
#include <Keyboard.h>

const int dirDown = 7;
const int dirUp = 6;
const int dirRight = 9;
const int dirLeft = 8;
const int CLK = 10;
const int DT = 4;
const int btnForward = 2;   
const int btnBackward = 3;  
const int btnFire = 5;
int currentStateCLK;
int previousStateCLK;

void setup() {
    pinMode(dirDown, INPUT_PULLUP);
    pinMode(dirUp, INPUT_PULLUP);
    pinMode(dirRight, INPUT_PULLUP);
    pinMode(dirLeft, INPUT_PULLUP);
    pinMode(btnForward, INPUT_PULLUP);
    pinMode(btnBackward, INPUT_PULLUP);
    pinMode(btnFire, INPUT_PULLUP);
    pinMode(CLK, INPUT);
    pinMode(DT, INPUT);
    Mouse.begin();
    Keyboard.begin();
    previousStateCLK = digitalRead(CLK);
}

void loop() {
    if (digitalRead(dirDown) == LOW) {
        Mouse.move(0, 5);
    }
    if (digitalRead(dirUp) == LOW) {
        Mouse.move(0, -5);
    }
    if (digitalRead(dirRight) == LOW) {
        Mouse.move(5, 0);
    }
    if (digitalRead(dirLeft) == LOW) {
        Mouse.move(-5, 0);
    }

    currentStateCLK = digitalRead(CLK);
    if (currentStateCLK != previousStateCLK && currentStateCLK == HIGH) {
        delay(1);

        int stateDT = digitalRead(DT);

        if (stateDT != currentStateCLK) {
            Keyboard.press('D');
        } else {
            Keyboard.press('A');
        }

        delay(50); 
        Keyboard.releaseAll();
    }
    previousStateCLK = currentStateCLK;
  if (digitalRead(btnForward) == LOW) {
      Keyboard.press('W');
  } else {
      Keyboard.release('W');
  }
  if (digitalRead(btnBackward) == LOW) {
      Keyboard.press('S');
  } else {
      Keyboard.release('S');
  }
  if (digitalRead(btnFire) == LOW) {
      Keyboard.press(' ');
  } else {
      Keyboard.release(' ');
  }
    delay(10);
    
}
